<?php


// interface Service
// {
// //---------------
// 
//     public function load   ( $concept, $parents = false, $id = false );
// 
// //---------------
// 
//     public function search ( $justthese = false, $params = false, $criteria = false );
// 
// //---------------
// 
//     public function delete ( $justthese = false, $params = false, $criteria = false );
// 
// //---------------
//    
//     public function update ( $data,              $params = false, $criteria = false );
// 
// //---------------
// 
//     public function create ( $data,              $params = false );
// 
// //---------------
// 
//     public function connect( $config );
// 
//     public function close();
// 
//     public function setup();
// 
//     public function teardown();
// }


interface Service
{
//---------------

    public function find     ( $concept,      $parents = false, $justthese = false, $criteria = false );

    public function retrieve ( $concept, $id, $parents = false, $justthese = false, $criteria = false );

//---------------

    public function deleteAll( $concept,      $parents = false, $justthese = false, $criteria = false ); // avaliar

    public function delete   ( $concept, $id, $parents = false, $justthese = false, $criteria = false );

//---------------

    public function replace  ( $concept,      $parents = false, $data,		   $criteria = false );

    public function update   ( $concept, $id, $parents = false, $data,		   $criteria = false );

//---------------

    public function create   ( $concept,      $parents = false, $data );

//---------------

    public function connect  ( $config );

    public function close();

    public function setup();

    public function teardown();
}